﻿using System;
using System.Collections.Generic;
using UnityEngine;

namespace Mod
{
	public class Mod : MonoBehaviour
	{

		public static void Main()
		{

			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Tank"),
					NameOverride = "M1A2 Abrams",
					NameToOrderByOverride = "The M1A2 Abrams",
					DescriptionOverride = "M1A2 Abrams main battle tank is manufactured by General Dynamics Land Systems. The first M1 tank was produced in 1978, and the M1A2 in 1986.",
					CategoryOverride = ModAPI.FindCategory("Vehicles"),
					ThumbnailOverride = ModAPI.LoadSprite("Textures/Thumb.png"),
					AfterSpawn = (Instance) =>
					{
						Destroy(Instance.GetComponentInChildren<RandomCarTextureBehaviour>());

						Instance.transform.Find("Barrel").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Barrel.png");
						Instance.transform.Find("Body").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Body.png");
						Instance.transform.Find("Wheel").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Wheel0.png");
						Instance.transform.Find("Wheel (1)").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Wheel1.png");
						Instance.transform.Find("Wheel (2)").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Wheel1.png");
						Instance.transform.Find("Wheel (3)").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Wheel1.png");
						Instance.transform.Find("Wheel (4)").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Wheel1.png");
						Instance.transform.Find("Wheel (5)").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Wheel1.png");
						Instance.transform.Find("Wheel (6)").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Wheel1.png");
						Instance.transform.Find("Wheel (7)").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Wheel1.png");
						Instance.transform.Find("Wheel (8)").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Wheel0.png");

					
						
					}
				}
			);
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "M1A2 Gun Mount 1",
                    NameToOrderByOverride = "The M1A2 Gun Mount 1",
                    DescriptionOverride = "M1A2 Gun Mount 1 for the Abrams.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Mount1Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Mount1.png", 1f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 13f;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.FixColliders();
                    }
                }
            ); 
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "M1A2 Gun Mount 2",
                    NameToOrderByOverride = "The M1A2 Gun Mount 2",
                    DescriptionOverride = "M1A2 Gun Mount 2 for the Abrams.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Mount2Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Mount2.png", 1f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 13f;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.FixColliders();
                    }
                }
            ); 
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "M1A2 Gun Mount 3",
                    NameToOrderByOverride = "The M1A2 Gun Mount 3",
                    DescriptionOverride = "M1A2 Gun Mount 3 for the Abrams.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Mount3Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Mount3.png", 1f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 13f;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.FixColliders();
                    }
                }
            ); 
		}
	}
}

